<template src="./createInfoComponent.htm"></template>

<script>

    import Vue from 'vue';
    import FileComponent from '../../../../../inputs/FileComponent.vue';
    import SelectComponent from '../../../../../inputs/SelectComponent.vue';
    import ValidationErrorsMixin from '../../../../../mixins/validationErrorsMixin.js';

    Vue.component('file-component', FileComponent);
    Vue.component('select-component', SelectComponent);

    export default {

        data() {

            return {

                baseInfo: {

                    name: '',

                    description: '',

                    parent: null,

                    icon: {

                        file: null,

                        preview: null
                    }
                }
            }
        },

        mixins: [ ValidationErrorsMixin ],

        methods: {

            /**
             * Assign processed file (image) to icon.
             */
            pushIcon(icon) {

                this.baseInfo.icon = icon;
            },


            /**
             * @param category
             */
            createCategoryStoreObject(category) {

                return {

                    name: category.name,

                    description: category.description,

                    parent_id: category.parent,

                    icon: category.icon.file
                }
            }
        },

        computed: {

            /**
             * Data for categories select from store getter.
             **/
            selectCategoriesList() {

                return this.$store.getters.selectCategories;
            }
        },

        watch: {

            /**
             * Push base info to store on each attribute change
             **/
            baseInfo: {

                handler(newBaseInfo) {

                    this.$store.dispatch('setCategory', this.createCategoryStoreObject(newBaseInfo));
                },

                deep: true
            }
        }
    }

</script>